
	
	
	subroutine Koeficijenti(n,x,y,p,d,h,hp,ph,ier)
	implicit double precision (a-h,o-z)

	integer ier,n
	dimension x(0:n),y(0:n),p(0:n),d(0:n),h(0:n),hp(0:n),ph(0:n)

!	potprogram izracunava koeficijente exponencijalnog splinea
!
!	ulaz
!		n - zadaje broj cvorova	(broj cvorova je n+1)
!		x - vektor apscisa tocaka kroz koje treba provuci krivulju (0:n)
!		y - vektor ordinata tocaka kroz koje treba provuci krivulju	(0:n)
!		p - vektor parametara napetosti	(0:n-1)
!
!
!
!	izlaz
!		ier - zastavica koja signalizira gresku; 
!					ier=1 ako je broj cvorova manji od 4
!					ier=2 ako apscise zadanih tocaka nisu poredane po velicini
!					ier=3 ako LU faktorizacija nije izvrsena	
!		d - vektor vrijednosti drugih derivacija splajna u cvorovima (0:n), 
!			zadani su rubni uvjeti d(0)=d(n)=0
!		h - vektor duljina intervala (0:n-1)
!		hp - vektor produkata abs(p(i)*h(i)), (0:n-1)
!		ph - vektor vrijednosti exp(-hp(i)), (0:n-1)





!	izracunavanje elemenata tridijagonalnog sustava
	integer i,i1,n1,iflag,j
	double precision c,c1,c2,u,v,s,fi
	double precision q(50),r(50),w(50,50),b(50)

	ier=0
	if (n.lt.3) then
		ier=1
		return
	endif
	
	n1=n-1
	u=y(0)
	do 20 i=1,n
		
		i1=i-1
		h(i1)=x(i)-x(i1)
		if (h(i1).lt.0) then 
			ier=2
			return
		endif
		v=y(i)
		hp(i1)=abs(h(i1)*p(i1))
		if (h(i1).eq.0) then
			d(i)=v
		else
			d(i)=(v-u)/h(i1)
			u=v
		endif

		if (hp(i1).gt.(0.5)) then
			ph(i1)=exp(-hp(i1))
			c=ph(i1)*ph(i1)
			c1=1.0d0-c
			c2=c1/hp(i1)
			c1=c1*hp(i1)/h(i1)
			q(i)=(1.0d0-c2+c)/c1
			r(i)=(c2-2.0d0*ph(i1))/c1
		else
			
			c=hp(i1)*hp(i1)
			call Phi(c,fi)
			ph(i1)=fi
			s=h(i1)/(1.0d0+c*ph(i1))
			c=c*0.25d0
			c2=1.0d0+c*fi
			q(i)=(0.5d0*c2*c2-ph(i1))*s
			r(i)=ph(i1)*s
			
		endif
20	continue

!	rjesenje tridijagonalnog sustava s - dijagonalom: q(i)+q(i+1)
!									   - van dijagonale: r(i), i=2,..,n1
!									   - desnom stranom: d(i+1)-d(i)

	

	do 21 i=1,n1
		do 21 j=1,n1
			w(i,j)=0.0d0
21	continue
	do 22 i=1,n1
		w(2,i)=q(i)+q(i+1)
		if (i.lt.n) w(3,i)=r(i+1)
		if (i.gt.1) w(1,i)=r(i)
22	continue
	do 23 i=1,n1
		b(i)=d(i+1)-d(i)
23	continue

	d(0)=0.0d0
	d(n)=0.0d0

	call banfac(w,n1,1,1,iflag)
	if (iflag.eq.2) then
		ier=3 
		return
	endif
	call banslv(w,n1,1,1,b)

	do 24 i=1,n1
		d(i)=b(i)
24	continue
	
	end	subroutine

	
